<template>
  <div class="ValidationsWrapper">
    <PButton
      :label="buttonLabel"
      class="p-button-sm p-button-text p-button-rounded ValidationsWrapper__Button"
      @click="handleClick"
    />

    <span v-if="validations.length">
      {{ t('resource.controlPointValidation.approvedBy') }}
    </span>

    <PAvatarGroup v-if="validations.length" class="Validations">
      <UserAvatar
        v-for="validation in validations"
        :key="validation.id"
        class="Validations__Item"
        :user-id="validation.verifier"
        :label="getValidationLabel(validation)[0].toUpperCase()"
        :title="getValidationLabel(validation)"
      />
    </PAvatarGroup>
  </div>
</template>

<script lang="ts" setup>
import { ControlPoint } from '@/api/resources/controlPoint'
import { onMounted, toRefs } from 'vue'
import { useI18n } from 'vue-i18n'
import { useValidation } from '@/pages/tasks/useValidation'
import { UserAvatar } from '@/components/avatar'

const { t } = useI18n()
const props = defineProps<{
  controlPoint: ControlPoint['id']
}>()

const { controlPoint } = toRefs(props)

const {
  validations,
  loadValidations,
  handleClick,
  buttonLabel,
  getValidationLabel,
} = useValidation(controlPoint, t)

onMounted(loadValidations)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.Validations {
  display: inline-flex;
  flex-direction: row;
  justify-items: center;
  padding: v.$spacing-4;
  list-style: none;

  &__Item {
    cursor: default;
    transition: margin 250ms ease-in-out;

    &:hover {
      margin-right: 20px;
    }
  }
}

.ValidationsWrapper {
  display: flex;
  flex-direction: row;
  align-items: center;

  &__Button {
    margin-right: v.$spacing-2;
  }
}
</style>
